#!/usr/bin/perl

use File::HomeDir;
use CGI qw/:standard/;
use Config::Simple;
use Cwd 'abs_path';
use IO::Socket::INET;
use HTML::Entities;
use String::Escape qw( unquotemeta );
use warnings;
use strict;
no strict "refs"; # we need it for template system

my  $home = File::HomeDir->my_home;
my  $lang;
my  $installfolder;
my  $cfg;
my  $conf;
our $psubfolder;
our $template_title;
our $namef;
our $value;
our %query;
our $cache;
our $helptext;
	
our $miniserver;
our $select_ms;
our $debug;
our $select_debug;

our $udp_port;
our $e3dc_ip;
our $e3dc_user;
our $e3dc_pass;
our $e3dc_aes;

our $looptime_history;
our $looptime_status;

our $send_basic_active;
our $select_send_basic_active;
our $send_basic_kwh_active;
our $select_send_basic_kwh_active;
our $send_status_active;
our $select_send_status_active;
our $send_history_active;
our $select_send_history_active;


our $send_history_year_active;
our $select_send_history_year_active;
our $send_history_month_active;
our $select_send_history_month_active;
our $send_history_last_month_active;
our $select_send_history_last_month_active;
our $send_history_day_active;
our $select_send_history_day_active;
our $send_history_yesterday_active;
our $select_send_history_yesterday_active;

our $savedata;

# Read Settings
$cfg             = new Config::Simple("$home/config/system/general.cfg");
$installfolder   = $cfg->param("BASE.INSTALLFOLDER");
$lang            = $cfg->param("BASE.LANG");

print "Content-Type: text/html\n\n";

# Parse URL
foreach (split(/&/,$ENV{"QUERY_STRING"}))
{
  ($namef,$value) = split(/=/,$_,2);
  $namef =~ tr/+/ /;
  $namef =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $query{$namef} = $value;
}

# Set parameters coming in - GET over POST
if ( !$query{'miniserver'} ) { if ( param('miniserver') ) { $miniserver = quotemeta(param('miniserver')); } else { $miniserver = $miniserver;  } } else { $miniserver = quotemeta($query{'miniserver'}); }
if ( !$query{'debug'} ) { if ( param('debug') ) { $debug = quotemeta(param('debug')); } else { $debug = $debug;  } } else { $debug = quotemeta($query{'debug'}); }

if ( !$query{'udp_port'} ) { if ( param('udp_port') ) { $udp_port = quotemeta(param('udp_port')); } else { $udp_port = $udp_port; } } else { $udp_port = quotemeta($query{'udp_port'}); }
if ( !$query{'e3dc_ip'} ) { if ( param('e3dc_ip')  ) { $e3dc_ip = quotemeta(param('e3dc_ip')); } else { $e3dc_ip = $e3dc_ip;  } } else { $e3dc_ip = quotemeta($query{'e3dc_ip'}); }
if ( !$query{'e3dc_user'} ) { if ( param('e3dc_ip')  ) { $e3dc_user = quotemeta(param('e3dc_user')); } else { $e3dc_user = $e3dc_user;  } } else { $e3dc_user = quotemeta($query{'e3dc_user'}); }
if ( !$query{'e3dc_pass'} ) { if ( param('e3dc_pass')  ) { $e3dc_pass = quotemeta(param('e3dc_pass')); } else { $e3dc_pass = $e3dc_pass;  } } else { $e3dc_pass = quotemeta($query{'e3dc_pass'}); }
if ( !$query{'e3dc_aes'} ) { if ( param('e3dc_aes')  ) { $e3dc_aes = quotemeta(param('e3dc_aes')); } else { $e3dc_aes = $e3dc_aes;  } } else { $e3dc_aes = quotemeta($query{'e3dc_aes'}); }

if ( !$query{'send_basic_active'} ) { if ( param('send_basic_active')  ) { $send_basic_active = quotemeta(param('send_basic_active')); } else { $send_basic_active = $send_basic_active; } } else { $send_basic_active = quotemeta($query{'send_basic_active'}); }
if ( !$query{'send_basic_kwh_active'} ) { if ( param('send_basic_kwh_active')  ) { $send_basic_kwh_active = quotemeta(param('send_basic_kwh_active')); } else { $send_basic_kwh_active = $send_basic_kwh_active; } } else { $send_basic_kwh_active = quotemeta($query{'send_basic_kwh_active'}); }
if ( !$query{'send_history_active'} ) { if ( param('send_history_active') ) { $send_history_active = quotemeta(param('send_history_active')); } else { $send_history_active = $send_history_active; } } else { $send_history_active = quotemeta($query{'send_history_active'}); }
if ( !$query{'send_status_active'} ) { if ( param('send_status_active') ) { $send_status_active = quotemeta(param('send_status_active')); } else { $send_status_active = $send_status_active; } } else { $send_status_active = quotemeta($query{'send_status_active'}); }

if ( !$query{'send_history_year_active'} ) { if ( param('send_history_year_active') ) { $send_history_year_active = quotemeta(param('send_history_year_active')); } else { $send_history_year_active = $send_history_year_active; } } else { $send_history_year_active = quotemeta($query{'send_history_year_active'}); }
if ( !$query{'send_history_month_active'} ) { if ( param('send_history_month_active') ) { $send_history_month_active = quotemeta(param('send_history_month_active')); } else { $send_history_month_active = $send_history_month_active; } } else { $send_history_month_active = quotemeta($query{'send_history_month_active'}); }
if ( !$query{'send_history_last_month_active'} ) { if ( param('send_history_last_month_active') ) { $send_history_last_month_active = quotemeta(param('send_history_last_month_active')); } else { $send_history_last_month_active = $send_history_last_month_active; } } else { $send_history_last_month_active = quotemeta($query{'send_history_last_month_active'}); }
if ( !$query{'send_history_day_active'} ) { if ( param('send_history_day_active') ) { $send_history_day_active = quotemeta(param('send_history_day_active')); } else { $send_history_day_active = $send_history_day_active; } } else { $send_history_day_active = quotemeta($query{'send_history_day_active'}); }
if ( !$query{'send_history_yesterday_active'} ) { if ( param('send_history_yesterday_active') ) { $send_history_yesterday_active = quotemeta(param('send_history_yesterday_active')); } else { $send_history_yesterday_active = $send_history_yesterday_active; } } else { $send_history_yesterday_active = quotemeta($query{'send_history_yesterday_active'}); }


if ( !$query{'looptime_history'} ) { if ( param('looptime_history')  ) { $looptime_history = quotemeta(param('looptime_history')); } else { $looptime_history = $looptime_history;  } } else { $looptime_history = quotemeta($query{'looptime_history'}); }
if ( !$query{'looptime_status'} ) { if ( param('looptime_status')  ) { $looptime_status = quotemeta(param('looptime_status')); } else { $looptime_status = $looptime_status;  } } else { $looptime_status = quotemeta($query{'looptime_status'}); }


# Figure out in which subfolder we are installed
$psubfolder = abs_path($0);
$psubfolder =~ s/(.*)\/(.*)\/(.*)$/$2/g;

# Save settings to config file
if (param('savedata')) {
	$conf = new Config::Simple("$home/config/plugins/$psubfolder/e3dc.cfg");
	if ($debug ne 1) { $debug = 0 }
	if ($send_basic_active ne 1) { $send_basic_active = 0 }
	if ($send_basic_kwh_active ne 1) { $send_basic_kwh_active = 0 }
	if ($send_status_active ne 1) { $send_status_active = 0 }
	if ($send_history_active ne 1) { $send_history_active = 0 }	
	
	if ($send_history_year_active ne 1) { $send_history_year_active = 0 }	
	if ($send_history_month_active ne 1) { $send_history_month_active = 0 }	
	if ($send_history_last_month_active ne 1) { $send_history_last_month_active = 0 }	
	if ($send_history_day_active ne 1) { $send_history_day_active = 0 }	
	if ($send_history_yesterday_active ne 1) { $send_history_yesterday_active = 0 }	
	
	if ($looptime_history lt 60) { $looptime_history = 60 }
	if ($looptime_status lt 1) { $looptime_status = 30 }

	$conf->param('MINISERVER', unquotemeta("MINISERVER$miniserver"));		
	$conf->param('DEBUG', unquotemeta($debug));		

	$conf->param('UDP_PORT', unquotemeta($udp_port));
	$conf->param('E3DC_IP', unquotemeta($e3dc_ip));
	$conf->param('E3DC_USER', unquotemeta($e3dc_user));
	$conf->param('E3DC_PASS', unquotemeta($e3dc_pass));
	$conf->param('E3DC_AES', unquotemeta($e3dc_aes));	

	$conf->param('SEND_BASIC', unquotemeta($send_basic_active));
	$conf->param('SEND_BASIC_KWH', unquotemeta($send_basic_kwh_active));
	$conf->param('SEND_HISTORY', unquotemeta($send_history_active));
	$conf->param('SEND_STATUS', unquotemeta($send_status_active));

	$conf->param('SEND_HISTORY_YEAR', unquotemeta($send_history_year_active));
	$conf->param('SEND_HISTORY_MONTH', unquotemeta($send_history_month_active));
	$conf->param('SEND_HISTORY_MONTH_LAST', unquotemeta($send_history_last_month_active));
	$conf->param('SEND_HISTORY_DAY', unquotemeta($send_history_day_active));
	$conf->param('SEND_HISTORY_YESTERDAY', unquotemeta($send_history_yesterday_active));

	$conf->param('LOOPTIME_HISTORY', unquotemeta($looptime_history));
	$conf->param('LOOPTIME_STATUS', unquotemeta($looptime_status));
	
	$conf->save();
}

# Parse config file
$conf = new Config::Simple("$home/config/plugins/$psubfolder/e3dc.cfg");
$miniserver = encode_entities($conf->param('MINISERVER'));
$debug = encode_entities($conf->param('DEBUG'));

$udp_port = encode_entities($conf->param('UDP_PORT'));
$e3dc_ip = encode_entities($conf->param('E3DC_IP'));
$e3dc_user = encode_entities($conf->param('E3DC_USER'));
$e3dc_pass = encode_entities($conf->param('E3DC_PASS'));
$e3dc_aes = encode_entities($conf->param('E3DC_AES'));

$send_basic_active = encode_entities($conf->param('SEND_BASIC'));
$send_basic_kwh_active = encode_entities($conf->param('SEND_BASIC_KWH'));
$send_history_active = encode_entities($conf->param('SEND_HISTORY'));
$send_status_active = encode_entities($conf->param('SEND_STATUS'));

$send_history_year_active = encode_entities($conf->param('SEND_HISTORY_YEAR'));
$send_history_month_active = encode_entities($conf->param('SEND_HISTORY_MONTH'));
$send_history_last_month_active = encode_entities($conf->param('SEND_HISTORY_MONTH_LAST'));
$send_history_day_active = encode_entities($conf->param('SEND_HISTORY_DAY'));
$send_history_yesterday_active = encode_entities($conf->param('SEND_HISTORY_YESTERDAY'));

$looptime_history = encode_entities($conf->param('LOOPTIME_HISTORY'));
$looptime_status = encode_entities($conf->param('LOOPTIME_STATUS'));


# Set Enabled / Disabled switch
if ($send_basic_active eq "1") {
	$select_send_basic_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_basic_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_basic_kwh_active eq "1") {
	$select_send_basic_kwh_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_basic_kwh_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_history_active eq "1") {
	$select_send_history_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_history_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_status_active eq "1") {
	$select_send_status_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_status_active = '<option value="0" selected>off</option><option value="1">on</option>';
}

if ($send_history_year_active eq "1") {
	$select_send_history_year_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_history_year_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_history_month_active eq "1") {
	$select_send_history_month_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_history_month_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_history_last_month_active eq "1") {
	$select_send_history_last_month_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_history_last_month_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_history_day_active eq "1") {
	$select_send_history_day_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_history_day_active = '<option value="0" selected>off</option><option value="1">on</option>';
}
if ($send_history_yesterday_active eq "1") {
	$select_send_history_yesterday_active = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_send_history_yesterday_active = '<option value="0" selected>off</option><option value="1">on</option>';
}

if ($debug eq "1") {
	$select_debug = '<option value="0">off</option><option value="1" selected>on</option>';
} else {
	$select_debug = '<option value="0" selected>off</option><option value="1">on</option>';
}


# ---------------------------------------
# Fill Miniserver selection dropdown
# ---------------------------------------
for (my $i = 1; $i <= $cfg->param('BASE.MINISERVERS');$i++) {
	if ("MINISERVER$i" eq $miniserver) {
		$select_ms .= '<option selected value="'.$i.'">'.$cfg->param("MINISERVER$i.NAME")."</option>\n";
	} else {
		$select_ms .= '<option value="'.$i.'">'.$cfg->param("MINISERVER$i.NAME")."</option>\n";
	}
}

# Title
$template_title = "E3DC2Lox";

# Create help page
$helptext = "<b>Hilfe</b><br>Wenn ihr Hilfe beim Einrichten benötigt findet ihr diese im LoxWiki.";
$helptext = $helptext . "<br><a href='http://www.loxwiki.eu/display/LOXBERRY/MiRobot2Lox' target='_blank'>LoxWiki - MiRobot2Lox</a>";
$helptext = $helptext . "<br><br><b>Debug/Log</b><br>Um Debug zu starten, den Schalter auf on stellen und speichern.<br>Die Log-Datei kann hier eingesehen werden. ";
$helptext = $helptext . "<a href='http://loxberry/admin/system/tools/logfile.cgi?logfile=plugins/mirobot2lox/mirobot2lox.log&header=txt' target='_blank'>Log-File - MiRobot2Lox</a>";
$helptext = $helptext . "<br><br><b>Achtung!</b> Wenn Debug aktiv ist werden sehr viele Daten ins Log geschrieben. Bitte nur bei Problemen nutzen.";


# Currently only german is supported - so overwrite user language settings:
$lang = "de";

# Load header and replace HTML Markup <!--$VARNAME--> with perl variable $VARNAME
open(F,"$installfolder/templates/system/$lang/header.html") || die "Missing template system/$lang/header.html";
  while (<F>) {
    $_ =~ s/<!--\$(.*?)-->/${$1}/g;
    print $_;
  }
close(F);

# Load content from template
open(F,"$installfolder/templates/plugins/$psubfolder/$lang/content.html") || die "Missing template $lang/content.html";
  while (<F>) {
    $_ =~ s/<!--\$(.*?)-->/${$1}/g;
    print $_;
  }
close(F);

# Load footer and replace HTML Markup <!--$VARNAME--> with perl variable $VARNAME
open(F,"$installfolder/templates/system/$lang/footer.html") || die "Missing template system/$lang/header.html";
  while (<F>) {
    $_ =~ s/<!--\$(.*?)-->/${$1}/g;
    print $_;
  }
close(F);

exit;